//ensemble de Mandelbrot en 320*200, criture directe en VRAM
//avec zoom continu
//lit les paramtres de dpart dans coord.dbl cr par mandelj.c
//ou,  dfaut, les paramtres saisis dans la ligne de commande
//criture des images intermdiaires dans le fichier mandzoom.ani
//version 2.00
//09/98 by Doodle
#include <conio.h>
#include <dos.h> //pr emit et outportb
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <iostream.h>

#define MAXX 128 				//points 
#define MAXY 96 				//calculer

#define MAXXECR 256			//taille de la
#define MAXYECR 192   		//fentre  l'cran

typedef unsigned long dword;
typedef unsigned int word;
typedef unsigned char byte;

void Init();
void putpixel(word x,word y,word c);
void WaitRetrace();
void setpalette(int offset);
void closegraph();
int sq(int in){return (in*in);}
byte TestePoint(double x,double y);
void affiche(int flag,double zoom);
void calcule(int flag,int index,int nbcol);

double largeur[2]={0.,0.},hauteur[2]={0.,0.};	//1/2 hauteurs et largeurs
double CENTREX,CENTREY;
byte ecr[2][MAXX][MAXY];


void main(int argc,char **argv)
{
   int i,j,flag=0,nbetap=8;
   int index=0; //o on en est dans le calcul partiel
	double zoom=2.,zoommult=pow(2.,1./(double)(nbetap+1));

   if(argc==4){
      CENTREX=atof(argv[1]);			CENTREY=atof(argv[2]);
   	largeur[0]=1.2*atof(argv[3]); hauteur[0]=.9*atof(argv[3]);
   }
   else{
      FILE *f;
   	if((f=fopen("coord.dbl","rb"))==NULL){
			cout<<"Syntaxe:\nMANDZOO2 xCentre yCentre Echelle\n\n";
			exit(1);
		}
      else{
      	double bords[4];
         fread(bords,8,4,f);
         fclose(f);
         CENTREX=(bords[1]+bords[3])/2;	CENTREY=(bords[0]+bords[2])/2;
         largeur[0]=(bords[3]-bords[1])*pow(2.,28.);		hauteur[0]=largeur[0]*3./4.;
   }	}

	Init();
   //effectue le premier calcul
   calcule(flag,0,MAXX);
   affiche(flag,zoom);
   getch();
   //effectue le zoom continu tout en continuant les calculs
   for(i=0;i<28 && !(kbhit());i++){
      zoom=2.;
		index=0;
      flag=1-flag;	//nouvel indice pour le calcul
      largeur[flag]=largeur[1-flag]/2.;
      hauteur[flag]=hauteur[1-flag]/2.;
   	for(j=0;j<nbetap && !(kbhit());j++){
         calcule(flag,index,MAXX/nbetap);
         index+=MAXX/nbetap;
         affiche(1-flag,zoom);
      	zoom*=zoommult;
   }  }
   getch();
	closegraph();
}

void Init()
{ 	__emit__(0xb8,0x13,0x00,0xcd,0x10); //320*200*256
	setpalette(0);
   //efface l'ancien fichier d'animation
   FILE *f;
   f=fopen("mandzoom.ani","w");
   fflush(f);
   fclose(f);
}

void closegraph()
{	__emit__(0xb8,0x03,0x00,0xcd,0x10); //retour au mode texte
}

void setpalette(int offset)
{	byte r,g,b;
	for(int i=0;i<256;i++){
		r=63/(sq((i+214)%256-128)/5000.+1.);
		g=63/(sq((i+129)%256-128)/5000.+1.);
		b=63/(sq((i+44)%256-128)/5000.+1.);
		outportb(0x3c8,i+offset);		outportb(0x3c9,r);
		outportb(0x3c9,g);      		outportb(0x3c9,b);
	}
	outportb(0x3c8,offset);   	outportb(0x3c9,0);
	outportb(0x3c9,0);      	outportb(0x3c9,0);
}

void putpixel(word x,word y,word c)
{	char far *Screen;
	Screen=(char far *)MK_FP(0xa000,0x0000);
	Screen[(dword)y*320ul+(dword)x]=(byte)c;
}

void WaitRetrace()
{
	asm mov dx,3DAh;
	l1:
	asm{in al,dx
		and al,08h
		jnz l1}
	l2:
	asm{in al,dx
		and al,08h
		jz  l2}
}


byte TestePoint(double x,double y)
{
	double xtmp,ytmp,re,im,taillemax=500.;
	int maxiter=2048,i;
	xtmp=x;	ytmp=y;
	for(i=0;i<maxiter;i++){
		re=xtmp*xtmp;	im=ytmp*ytmp;
		if(re+im>taillemax)break;
		ytmp=(xtmp*ytmp)+y;
		xtmp=(re-im)/2+x;
	}
	return (byte)(i==256?1:i);
}

void affiche(int flag,double zoom)
{
   if(flag==0 || flag==1){
	 	int i,j;
	   double itab,jtab,incr=1/zoom;
      itab=-((double)(MAXXECR>>1))/zoom+(MAXX>>1);
      WaitRetrace();
	   for(i=0;i<MAXXECR;i++){
         if(itab<MAXX && itab>=0){
            jtab=-((double)(MAXYECR>>1))/zoom+(MAXY>>1);
	   		for(j=0;j<MAXYECR;j++){
      	      //affichage du pixel s'il correspond  un lment existant
             	if(jtab<MAXY && jtab>=0)
						putpixel(i,j,ecr[flag][(int)itab][(int)jtab]);
               jtab+=incr;
			}	}
         itab+=incr;
}	}	}

void calcule(int flag,int index,int nbcol)
{
   int i,j;
   double x,y,xincr,yincr;
   x=CENTREX+((double)(index-(MAXX>>1)))*largeur[flag]/MAXX;
   xincr=largeur[flag]/MAXX;
   yincr=-hauteur[flag]/MAXY;
	for(i=index;i<index+nbcol && i<MAXX;i++){
      y=CENTREY+((double)(MAXY>>1))*hauteur[flag]/MAXY;
      for(j=0;j<MAXY;j++){
			ecr[flag][i][j]=TestePoint(x,y);
         y+=yincr;
      }
      x+=xincr;
   }
   if(index+nbcol==MAXX){	//crire l'image intermdiaire dans le fichier
		FILE *f;
      f=fopen("mandzoom.ani","ab");
      fwrite(ecr[flag],1,MAXX*MAXY,f);
      fclose(f);
   }
}
